/*  Pcsx - Pc Psx Emulator
 *  Copyright (C) 1999-2002  Pcsx Team
 *  Copyright (C) 2008 Andrew Burton
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "../libpcsxcore/sio.h"
#include "Linux.h"
#include "Config.h"

#ifndef __PCSX_CONFIGURE_DLG_H__
#define __PCSX_CONFIGURE_DLG_H__

G_BEGIN_DECLS

/* Preferences dialog object */
#define PCSX_TYPE_CONFIGURE_DIALOG        (pcsx_configure_dialog_get_type ())
#define PCSX_CONFIGURE_DIALOG(o)          (G_TYPE_CHECK_INSTANCE_CAST ((o), PCSX_TYPE_CONFIGURE_DIALOG, PcsxConfigureDialog))
#define PCSX_CONFIGURE_DIALOG_CLASS(k)    (G_TYPE_CHECK_CLASS_CAST((k), PCSX_TYPE_CONFIGURE_DIALOG, PcsxConfigureDialogClass))
#define PCSX_IS_CONFIGURE_DIALOG(o)       (G_TYPE_CHECK_INSTANCE_TYPE ((o), PCSX_TYPE_CONFIGURE_DIALOG))
#define PCSX_IS_CONFIGURE_DIALOG_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), PCSX_TYPE_CONFIGURE_DIALOG))
#define PCSX_CONFIGURE_DIALOG_GET_CLASS(o)	(G_TYPE_INSTANCE_GET_CLASS ((o), PCSX_TYPE_CONFIGURE_DIALOG, PcsxConfigureDialogClass))

typedef struct _PcsxConfigureDialog        PcsxConfigureDialog;
typedef struct _PcsxConfigureDialogClass   PcsxConfigureDialogClass;
typedef struct _PcsxConfigureDialogPrivate PcsxConfigureDialogPrivate;

struct _PcsxConfigureDialogClass {
	GtkDialogClass parent_class;
};

struct _PcsxConfigureDialog {
	GtkDialog parent;
	
	PcsxConfigureDialogPrivate *priv;
};

GType pcsx_configure_dialog_get_type (void);
GtkWidget *pcsx_configure_dialog_new (GtkWindow *parent);

G_END_DECLS

#endif /* __PCSX_CONFIGURE_DLG_H__ */