/*  Pcsx - Pc Psx Emulator
 *  Copyright (C) 1999-2002  Pcsx Team
 *  Copyright (C) 2009 Andrew Burton
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/stat.h>   /* For S_IRWXU and S_IRWXG */

#include "Linux.h"
#include "pcsx-file-handler.h"

static void
create_home_config_dir (gchar *directory);

/* Create a directory under the $HOME directory, if that directory doesn't already exist */
static void
create_home_config_dir (gchar *directory) {
	gchar *dir_name;
	dir_name = g_build_filename (g_get_home_dir (), directory, NULL);
	
	if (!g_file_test (dir_name, G_FILE_TEST_EXISTS)) {
		printf ("Directory %s does not exist, creating it... ", dir_name);
		g_mkdir (dir_name, S_IRWXU | S_IRWXG);
		printf ("OK\n");
	}
	
	g_free (dir_name);
}


void check_sub_directories () {
	create_home_config_dir (PCSX_DOT_DIR);
	create_home_config_dir (BIOS_DIR);
	create_home_config_dir (MEMCARD_DIR);
	create_home_config_dir (STATES_DIR);
	create_home_config_dir (PLUGINS_DIR);
	create_home_config_dir (PLUGINS_CFG_DIR);
}