#ifndef __PCSX_MAIN_WIN_H__
#define __PCSX_MAIN_WIN_H__

G_BEGIN_DECLS

/* Preferences dialog object */
#define PCSX_TYPE_MAIN_WIN        (pcsx_main_win_get_type ())
#define PCSX_MAIN_WIN(o)          (G_TYPE_CHECK_INSTANCE_CAST ((o), PCSX_TYPE_MAIN_WIN, PcsxMainWin))
#define PCSX_MAIN_WIN_CLASS(k)    (G_TYPE_CHECK_CLASS_CAST((k), PCSX_TYPE_MAIN_WIN, PcsxMainWinClass))
#define PCSX_IS_MAIN_WIN(o)       (G_TYPE_CHECK_INSTANCE_TYPE ((o), PCSX_TYPE_MAIN_WIN))
#define PCSX_IS_MAIN_WIN_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), PCSX_TYPE_MAIN_WIN))
#define PCSX_MAIN_WIN_GET_CLASS(o)	(G_TYPE_INSTANCE_GET_CLASS ((o), PCSX_TYPE_MAIN_WIN, PcsxMainWinClass))

typedef struct _PcsxMainWin        PcsxMainWin;
typedef struct _PcsxMainWinClass   PcsxMainWinClass;
typedef struct _PcsxMainWinPrivate PcsxMainWinPrivate;

struct _PcsxMainWinClass {
	GtkWindowClass parent_class;
};

struct _PcsxMainWin {
	GtkWindow parent;
	
	PcsxMainWinPrivate *priv;
};

/* The following menu entries are always enabled */
static const GtkActionEntry pcsx_menu_entries[] =
{
	/* Toplevel */
	{ "File", NULL, N_("_File") },
	{ "Emulator", NULL, N_("_Emulator") },
	{ "Config", NULL, N_("_Configuration") },
	{ "Help", NULL, N_("_Help") },

	/* File menu */
	{ "FileQuit", GTK_STOCK_QUIT, N_("_Quit"), "<control>Q", NULL, G_CALLBACK (OnFile_Exit) },

	/* Emulator menu */
	{ "EmulatorLoadBios", GTK_STOCK_EXECUTE, N_("Load BIOS Screen"), NULL, NULL, G_CALLBACK (on_open_bios_menu_activated) },
/*	{ "EmulatorResetMenu", GTK_STOCK_REFRESH, N_("Reset"), NULL, NULL, G_CALLBACK (OnEmu_Reset) },*/

	/* Configuration menu */
	{ "ConfigPrefs", GTK_STOCK_PREFERENCES, N_("_Preferences"), NULL, NULL, G_CALLBACK (on_pcsx_configure) },
	{ "ConfigMemcards", GTK_STOCK_FLOPPY, N_("Memory Cards"), NULL, NULL, G_CALLBACK (OnConf_Mcds) },
	{ "ConfigDebug", GTK_STOCK_MEDIA_RECORD, N_("Debug"), NULL, NULL, G_CALLBACK (OnConf_Dbg) },

	/* Help menu */
/*	{"HelpContents", GTK_STOCK_HELP, N_("_Contents"), "F1", N_("Open the PCSX manual"), G_CALLBACK (on_help_activate) },*/
	{ "HelpAbout", GTK_STOCK_ABOUT, NULL, NULL, N_("About this application"), G_CALLBACK (OnHelp_About) }
};

/* The following menu entries are enabled when the plugins have been configured */
static const GtkActionEntry pcsx_exec_menu_entries[] =
{
	/* File menu */

	{ "FileLoadExe", GTK_STOCK_EXECUTE, N_("Load PSX EXE"), NULL, NULL, G_CALLBACK (OnFile_RunExe) },
	{ "FileLoadState", GTK_STOCK_MISSING_IMAGE, N_("Load State"), NULL, NULL, G_CALLBACK (on_states_load_other) },
	{ "FileLoadImage", GTK_STOCK_CDROM, N_("Load ISO/Image"), NULL, NULL, G_CALLBACK (on_file_load_cdimage) },
	{ "EmulatorStart", GTK_STOCK_GO_FORWARD, N_("Start Emulation"), NULL, NULL, G_CALLBACK (on_start_emulation_menu_activated) },

};

GType pcsx_main_win_get_type (void);
GtkWidget *pcsx_main_win_new (GtkWindow *parent);

void pcsx_main_window_set_exec_grp_sensitive (PcsxMainWin *win, gboolean sensitive);

G_END_DECLS

#endif /* __PCSX_MAIN_WIN_H__ */